<!DOCTYPE html>
<html>

<head>
    <title>Lucky Dice Casino</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- class CSS để dùng trong bài -->
    <style>
        .picture-cover {
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>

<body>
    <div class="container-fluid bg-success picture-cover">

    </div>
    <div class="container">
        <div class="row">
            <div class="col-5 bg-white">
                <div class="row form-group">
                    <div class="col-12">
                        <!-- Tại dòng 2.1.1.1 thêm một div column rộng 12 đơn vị -->
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row form-group">
                    <!--Tại mỗi dòng 2.1.1.2 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4">
                        <!-- Chiều rộng 4 đơn vị (col-4) -->
                        <label>Username</label>
                    </div>
                    <div class="col-8">
                        <!-- Chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row form-group">
                    <!--Tại mỗi dòng 2.1.1.3 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4">
                        <!-- Chiều rộng 4 đơn vị (col-4) -->
                        <label>Firstname</label>
                    </div>
                    <div class="col-8">
                        <!-- Chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row form-group">
                    <!--Tại mỗi dòng 2.1.1.4 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4">
                        <!-- Chiều rộng 4 đơn vị (col-4) -->
                        <label>Lastname</label>
                    </div>
                    <div class="col-8">
                        <!-- Chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-4 text-center">
                <!-- Tại cột 2.1.2 tạo 3 div class row, cột 2.1.2 có thuộc tính căn giữa -->
                <div class="row">
                    <div class="col-12">
                        <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <input id="btn-dice" onclick="onBtnNemClick()" class="btn btn-success button-width w-75"
                            value="Ném" type="button">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3 text-center">
                <!-- Tại cột 2.1.3 tạo 2 div class row, cột 2.1.3 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12">
                        <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/xe-may.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row text-center form-group">
            <!-- Tại row 2.2 thêm một div column rộng 12 đơn vị -->
            <div class="col-12">
                <button id="btn-dice-history" onclick="onBtnDiceHistory()" class="btn btn-info button-width w-25">Dice
                    History</button>
                <button id="btn-voucher-history" onclick="onBtnVoucherHistory()"
                    class="btn btn-success button button-width w-25">Voucher History</button>
                <button id="btn-present-hisotry" onclick="onBtnGiftHistory()"
                    class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row">
            <!-- Tại row 2.3 thêm một div column rộng 12 đơn vị -->
            <div class="col-12">
                <table id="history-placeholder-table" class="table table-striped table-hover border">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <th>1</th>
                        <th>2</th>
                    </tr>
                    <tr>
                        <th>2</th>
                        <th>6</th>
                    </tr>
                    <tr>
                        <th>3</th>
                        <th>4</th>
                    </tr>
                    <tr>
                        <th>4</th>
                        <th>5</th>
                    </tr>
                    <tr>
                        <th>5</th>
                        <th>4</th>
                    </tr>
                </table>
            </div>
        </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";
    //const vBASE_URL = "devcamp-lucky-dice";
    const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    const gCOL_LUOT = 0; //Số thứ tự cột lượt
    const gCOL_DICE = 1; //Số thứ tự cột dice
    const gEND_OF_ROW_COL = -1;
    var gTable = document.getElementById("history-placeholder-table");
    var gTableBody = gTable.getElementsByTagName("tbody")[0];

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnNemClick() {
        //Tạo đối tượng để truyền dữ liệu giữa các bước
        var vUserObj = {
            username: "",
            firstname: "",
            lastname: "",
        };
        //Bước 1: Thu thập dữ liệu
        getData(vUserObj);
        //Bước 2: Kiểm tra dữ liệu
        var vIsCheck = validateData(vUserObj);
        if (vIsCheck) {
            var vXmlHttpDice = new XMLHttpRequest();
            //Bước 3: Gọi API server
            callApiServerDice(vXmlHttpDice, vUserObj);
            vXmlHttpDice.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                    //Bước 4: Xử lý response trả về từ server
                    processResponse(vXmlHttpDice);
                }
            }
        }
    }
    function onBtnDiceHistory() {
        console.log("Nút Dice History được ấn");
        //Tạo đối tượng để truyền dữ liệu giữa các bước
        var vUserObj = {
            username: "",
            firstname: "",
            lastname: "",
        };
        //Bước 1: Thu thập dữ liệu
        getData(vUserObj);
        //Bước 2: Kiểm tra dữ liệu
        var vIsCheck = validateData(vUserObj);
        if (vIsCheck) {
            var vXmlHttpDiceHistory = new XMLHttpRequest();
            //Bước 3: Gọi API Server
            callApiServerDiceHistory(vXmlHttpDiceHistory, vUserObj);
            vXmlHttpDiceHistory.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        //Bước 4: Xử lý response trả về từ server
                        processResponseDiceHistory(vXmlHttpDiceHistory);
                    }
                }
        }
    }

    function onBtnVoucherHistory() {
        console.log("Nút Voucher History được ấn!");
        //Tạo đối tượng để truyền dữ liệu giữa các bước 
        var vUserObj = {
            username: "",
            firstname: "",
            lastname: "",
        }
        //Bước 1: Thu thập dữ liệu
        getData(vUserObj);
        //Bước 2: Kiểm tra dữ liệu 
        var vIsCheck = validateData(vUserObj);
        if (vIsCheck) {
            var vXmlHttpVoucherHistory = new XMLHttpRequest();
            //Bước 3: Gọi API Server
            callApiServerVoucherHistory(vXmlHttpVoucherHistory, vUserObj);
            vXmlHttpVoucherHistory.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        //Bước 4: Xử lý response trả về từ server
                        processResponseVoucherHistory(vXmlHttpVoucherHistory);
                    }
                }
            }
        }

    function onBtnGiftHistory() {
        console.log("Nút Gift History được ấn!");
        //Tạo đối tượng để truyền dữ liệu giữa các bước 
        var vUserObj = {
            username: "",
            firstname: "",
            lastname: "",
        }
        //Bước 1: Thu thập dữ liệu
        getData(vUserObj);
        //Bước 2: Kiểm tra dữ liệu 
        var vIsCheck = validateData(vUserObj);
        if (vIsCheck) {
            var vXmlHttpGiftHistory = new XMLHttpRequest();
            //Bước 3: Gọi API Server
            callApiServerGiftHistory(vXmlHttpGiftHistory, vUserObj);
            vXmlHttpGiftHistory.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        //Bước 4: Xử lý response trả về từ server
                        processResponseGiftHistory(vXmlHttpGiftHistory);
                    }
                }
            }
        }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm gọi API Dice History
    function callApiServerDiceHistory(paramXmlHttpDiceHistory, paramDataUser) {
        paramXmlHttpDiceHistory.open("GET", vBASE_URL + "/dice-history?username=", true);
        paramXmlHttpDiceHistory.send();
    }
    //Hàm xử lý response trả về thành công
    function processResponseDiceHistory(paramXmlHttpDiceHistory) {
        "use strict";
        console.log(paramXmlHttpDiceHistory.responseText)
        // parsing to object 
        var vResponseToObjectDiceHistory = JSON.parse(paramXmlHttpDiceHistory.responseText);
        console.log(vResponseToObjectDiceHistory);
        // xoá dữ liệu trong bảng
        var table = document.getElementById("history-placeholder-table");
        while (table.rows.length > 0) {
            table.deleteRow(0);
        }

        var vNewRow = gTableBody.insertRow(gEND_OF_ROW_COL);
        var vHeaderGameCell = document.createElement("th");     //cột Lượt
        vHeaderGameCell.innerHTML = "Lượt";
        vNewRow.appendChild(vHeaderGameCell);

        var vHeaderResultCell = document.createElement("th");   //cột Kết quả
        vHeaderResultCell.innerHTML = "Kết Quả";
        vNewRow.appendChild(vHeaderResultCell);

        // truy xuất được phần tử trong thead trong table
        // cách truy xuất là bảng TagName, với cách này ta sẽ có một bảng các tbody trong bảng, ta lấy phần tử số 0 của mảng này

        for (var bI = 0; bI < vResponseToObjectDiceHistory.dices.length; bI++) {
            console.log("Dices: " + vResponseToObjectDiceHistory.dices[bI]);
            //thêm dòng 
            var bNewRow = gTableBody.insertRow(gEND_OF_ROW_COL);
            //thêm 2 cell lượt và dices 
            var bLuotCell = bNewRow.insertCell(gCOL_LUOT);
            var bDiceCell = bNewRow.insertCell(gCOL_DICE);
            //điền dữ liệu cho 2 cells
            bDiceCell.innerHTML = vResponseToObjectDiceHistory.dices[bI];
            bLuotCell.innerHTML = bI + 1;
        }
    }
    //Hàm gọi API Dice  
    function callApiServerDice(paramXmlHttpDice, paramDataUser) {
        paramXmlHttpDice.open("POST", vBASE_URL + "/dice", true);
        paramXmlHttpDice.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttpDice.send(JSON.stringify(paramDataUser));  //chuyển Json object sang string
    }
    //Hàm xử lý response trả về thành công
    function processResponse(paramXmlHttpDice) {
        "use strict";
        console.log(paramXmlHttpDice.responseText);
        // parsing to object
        var vResponseToObject = JSON.parse(paramXmlHttpDice.responseText);
        console.log(vResponseToObject);
        // get result dice
        var vDiceReady = vResponseToObject.dice;
        console.log("dice result: " + vDiceReady);
        //gọi hàm hiển thị dice
        changeDice(vDiceReady);
        //gọi hàm hiển thị lời nhắn
        changeNotification(vDiceReady);
        //gọi hàm hiển thị voucher
        changeVoucherId(vResponseToObject);
        //gọi hàm hiển thị ảnh phần thưởng 
        changeGift(vResponseToObject);
    }
    // Hàm hiển thị dice
    function changeDice(paramDice) {
        "use strict";
        var vImgDice = document.getElementById("img-dice");
        switch (paramDice) {
            case 1:
                vImgDice.src = "LuckyDiceImages/1.png";
                break;
            case 2:
                vImgDice.src = "LuckyDiceImages/2.png";
                break;
            case 3:
                vImgDice.src = "LuckyDiceImages/3.png";
                break;
            case 4:
                vImgDice.src = "LuckyDiceImages/4.png";
                break;
            case 5:
                vImgDice.src = "LuckyDiceImages/5.png";
                break;
            default:
                vImgDice.src = "LuckyDiceImages/6.png"
        }
    }
    // Hàm hiển thị lời nhắn
    function changeNotification(paramDice) {
        "use strict";
        var vNotification = document.getElementById("p-notification-dice");
        if (paramDice < 4) {
            vNotification.innerHTML = ("Chúc bạn may mắn lần sau !!! ");
        }
        else {
            vNotification.innerHTML = ("Chúc mừng bạn hãy chơi tiếp lần nữa !!!");
        }
    }
    //Hàm hiển thị voucher
    function changeVoucherId(paramResponseVoucher) {
        "use strict";
        var vPVoucherId = document.getElementById("p-voucher-id");
        var vPVoucherPercent = document.getElementById("p-voucher-percent");

        if (paramResponseVoucher.voucher != null) {
            vPVoucherId.innerHTML = paramResponseVoucher.voucher.maVoucher;
            vPVoucherPercent.innerHTML = paramResponseVoucher.voucher.phanTramGiamGia + "%";
        }
        else {
            vPVoucherId.innerHTML = "";
            vPVoucherPercent.innerHTML = "";
        }
    }
    //Hàm hiển thị ảnh phần thưởng 
    function changeGift(paramResponsePrize) {
        "use strict";
        var vImgPresent = document.getElementById("img-present");
        var vTenPhanThuong = paramResponsePrize.prize;
        switch (vTenPhanThuong) {
            case "Mũ":
                vImgPresent.src = "LuckyDiceImages/hat.jpg";
                break;
            case "Áo":
                vImgPresent.src = "LuckyDiceImages/t-shirt.png";
                break;
            case "Xe máy":
                vImgPresent.src = "LuckyDiceImages/xe-may.jpg";
                break;
            case "Ô tô":
                vImgPresent.src = "LuckyDiceImages/car.jpg";
                break;
            default:
                vImgPresent.src = "LuckyDiceImages/no-present.jpeg";
        }
    }
    // Hàm thu thập dữ liệu 
    function getData(paraDataUser) {
        var vInputUserName = document.getElementById("inp-user-name");
        var vInputFirstName = document.getElementById("inp-first-name");
        var vInputLastName = document.getElementById("inp-last-name");

        paraDataUser.username = vInputUserName.value.trim();
        paraDataUser.firstname = vInputFirstName.value.trim();
        paraDataUser.lastname = vInputLastName.value.trim();
    }
    //Hàm kiểm tra dữ liệu 
    function validateData(paraDataUser) {
        if (paraDataUser.username, paraDataUser.firstname, paraDataUser.lastname === "") {
            alert("Vui lòng điền thông tin !!!");
            return false;
        }
        if (paraDataUser.username == "") {
            alert("Cần nhập username !!!")
            return false;
        }
        if (paraDataUser.firstname == "") {
            alert("Cần nhập firstname !!!")
            return false;
        }
        if (paraDataUser.lastname == "") {
            alert("Cần nhập lastname !!!")
            return false;
        }
        return true;
    }

    //Hàm gọi API Voucher History
    function callApiServerVoucherHistory(paramXmlHttpVoucherHistory, paramDataUser) {
        paramXmlHttpVoucherHistory.open("GET", vBASE_URL + "/voucher-history?username=", true);
        paramXmlHttpVoucherHistory.send();
    }

    //Hàm xử lý response trả về Voucher History thành công
    function processResponseVoucherHistory(paramXmlHttpVoucherHistory) {
        "use strict";
        console.log(paramXmlHttpVoucherHistory.responseText)
        //Parsing to object
        var vResponseToObjectVoucherHistory = JSON.parse(paramXmlHttpVoucherHistory.responseText);
        //var vResponseToObjectVoucherHistoryToString = JSON.stringify(vResponseToObjectVoucherHistory);
        console.log(vResponseToObjectVoucherHistory);
        //Xoá dữ liệu trong bảng
        var table = document.getElementById("history-placeholder-table");
        while (table.rows.length > 0) {
            table.deleteRow(0);
        }

        var vNewRow = gTableBody.insertRow(gEND_OF_ROW_COL);
        var vHeaderGameCell = document.createElement("th"); //cột STT
        vHeaderGameCell.innerHTML = "STT";
        vNewRow.appendChild(vHeaderGameCell);

        var vHeaderResultCell = document.createElement("th");
        vHeaderResultCell.innerHTML = "Voucher";
        vNewRow.appendChild(vHeaderResultCell)

        //Truy xuất được phần tử trong thead trong table 
        //Cách truy xuất là bảng TagName, với cách này ta sẽ có một bảng các tbody trong bảng, ta lấy phần tử số 0 của mảng này

        for (var bI = 0; bI < vResponseToObjectVoucherHistory.vouchers.length; bI++) {
            console.log("Vouchers: " + vResponseToObjectVoucherHistory.vouchers[bI].maVoucher);
            //thêm dòng
            var bNewRow = gTableBody.insertRow(gEND_OF_ROW_COL);
            //thêm 2 cell stt và voucher
            var bSttCell = bNewRow.insertCell(gCOL_LUOT);
            var bVoucherCell = bNewRow.insertCell(gCOL_DICE);
            //điền dữ liệu cho 2 cells
            bVoucherCell.innerHTML = vResponseToObjectVoucherHistory.vouchers[bI];
            bSttCell.innerHTML = bI + 1;
        }
    }

    //Hàm API Gift History
    function callApiServerGiftHistory(paramXmlHttpGiftHistory, paramDataUser) {
        paramXmlHttpGiftHistory.open("GET", vBASE_URL + "/prize-history?username=", true);
        paramXmlHttpGiftHistory.send();
    }

    //Hàm xử lý response trả về Gift History thành công 
    function processResponseGiftHistory(paramXmlHttpGiftHistory) {
        "use strict";
        console.log(paramXmlHttpGiftHistory.responseText);
        //Parsing to object
        var vResponseToObjectGiftHistory = JSON.parse(paramXmlHttpGiftHistory.responseText);
        console.log(vResponseToObjectGiftHistory);
        //Xoá dữ liệu trong bảng
        var table = document.getElementById("history-placeholder-table");
        while (table.rows.length > 0) {
            table.deleteRow(0);
        }

        var vNewRow = gTableBody.insertRow(gEND_OF_ROW_COL);
        var vHeaderGameCell = document.createElement("th"); //cột STT
        vHeaderGameCell.innerHTML = "STT";
        vNewRow.appendChild(vHeaderGameCell);

        var vHeaderResultCell = document.createElement("th");
        vHeaderResultCell.innerHTML = "Gift";
        vNewRow.appendChild(vHeaderResultCell);

        //Truy xuất được phần tử trong thead trong table
        //Cách truy xuất là bảng TagName, với cách này ta sẽ có một bảng các tbody trong bảng, ta lấy phần tử số 0 của mảng này
        for (var bI = 0; bI < vResponseToObjectGiftHistory.prizes.length; bI++) {
            console.log("Gifts: " + vResponseToObjectGiftHistory.prizes[bI]);
            //thêm dòng
            var bNewRow = gTableBody.insertRow(gEND_OF_ROW_COL);
            //thêm 2 cell stt và gift
            var bSttCell = bNewRow.insertCell(gCOL_LUOT);
            var bGiftCell = bNewRow.insertCell(gCOL_DICE);
            //điền dữ liệu cho 2 cells
            bGiftCell.innerHTML = vResponseToObjectGiftHistory.prizes[bI];
            bSttCell.innerHTML = bI + 1;
        }
    }


</script>

</html>